Function into a condition ?


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Function into a condition ?
# 1  
Old 03-14-2013
Function into a condition ?

Hello,

How can i put a function into a condition ?
g1 is my function
I tested this in vain

Code:
if [ g1 $1 $2 $3 -ne 0 ];then

Code:
if [ $(g1 $1 $2 $3) -ne 0 ];then

Thanks for yours suggestions
# 2  
Old 03-14-2013
Quote:
Originally Posted by amazigh42
Hello,

How can i put a function into a condition ?
g1 is my function
I tested this in vain

Code:
if [ g1 $1 $2 $3 -ne 0 ];then

Code:
if [ $(g1 $1 $2 $3) -ne 0 ];then

Thanks for yours suggestions
I think function's in bash doesn't accept any variables.

So it should better to define those values before you call your function.

sth like..

Code:
function g1 () {
    echo $((a+b+c))
 }
 
 a=3
 b=4
 c=5
 
 if [ $(g1) -ne 0 ];then
 g1  #do what you want to do..
 fi

Regards,

pamu
# 3  
Old 03-14-2013
Thanks pamu for your help
Whatever i want, if there is a bad parameter in the input file, the function f1 should not process the line with a bad parameter.
I put your suggestion in red but i have this return code.

Code:
line 58: -ne: command not found
line 58: [: missing `]'

I notify this line in green in the script.

Code:
cat file
2013-03-31 09 23
2013-03-31 09 23
#2013-03-31 09 32

Code:
./myscript file

Code:
#!/bin/sh
#########################################################################
DATE=$1
HOUR=$2
MN=$3
function g1 () {
  EC=0
  case "$1" in

    ([1-9][0-9][0-9][0-9]-0[1-9]-0[1-9] | [1-9][0-9][0-9][0-9]-0[1-9]-1[0-9] | [1-9][0-9][0-9][0-9]-0[1-9]-2[0-9] | [1-9][0-9][0-9][0-9]-0[1-9]-3[0-1] | [1-9][0-9][0-9][0-9]-1[0-2]-0[1-9] | [1-9][0-9][0-9][0-9]-1[0-2]-1[0-9] | [1-9][0-9][0-9][0-9]-1[0-2]-2[0-9] | [1-9][0-9][0-9][0-9]-1[0-2]-3[0-1])
# nothing, OK !
    ;;
    (*)
      echo 'Fatal, $1 = '"'$1'"', Date not conform OR absent' >&2
      EC=1
    ;;
  esac

   case "$2" in
     ([01][0-9] | 2[0-3])
        # nothing, OK !
    ;;
    (*)
      echo 'Fatal, $2 = '"'$2'"', Hour in 2 digits between 00 and 23' >&2
      EC=1
    ;;
   esac

   case "$3" in

    ([01][0-9] | [2-5][0-9])
      # nothing, OK !
     ;;
    (*)
      echo 'Fatal, $3 = '"'$3'"', Minute in two digits between 00 and 59' >&2
      EC=1
    ;;
   esac
   [ "$EC" = 1 ]
}

f1() {
echo -e "$DATE $HOUR $MIN"
}

case $# in
        0)      echo -e "# comment1\n# comment2" > list_file
                read -p "Please fill in this list_file: "

                echo $REPLY
                ;;
        1)     if [ ! -f "$1" ]
               then  > $1 && echo -e "# comment1\n# comment1" > $1
                        read -p "Please fill in "$1": "

                        echo $REPLY
               else
                        if [ -f "$1" -a $(grep -v '^#' "$1" | wc -l ) -ne 0 | $(g1 $arg1 $arg2 $arg3) -ne 0 ] # line 58
                        then
                                grep -v '^#' "$1" |
                                                while read arg1 arg2 arg3
                                                do f1 $arg1 $arg2 $arg3
                                                done
                         else
                                        echo "Errors found in date/time - exiting now" >&2
                                        exit 1
                          fi
                                read -p "Please fill in "$1": "
                                echo $REPLY
                fi
               ;;

        3)      echo -e "# Fill in the 3 variables below\n# DATE HOUR MN" > $1
                echo $2 $3 $4 >> "$1"                  # concatenation of variables in $ 1
                                grep -v '^#' "$1" | # Omits the comments
                                while read arg1 arg2 arg3 # Parse the parameters
                                do f1 $arg1 $arg2 $arg3 # Processing parameters for the function f1
                                done
                ;;
 *)      echo "error msg"; exit
esac

# 4  
Old 03-14-2013
Quote:
Originally Posted by pamu
I think function's in bash doesn't accept any variables.
Incorrect, they take parameters just fine.

You call them directly, outside [ ], like you would an external program.

Code:
if g1 $1 $2 $3
then
...
else
...
fi

And your function should use return to give an integer value that if can use in this manner. It's like exit but only quits a function or sourced script instead of the entire program. Zero means success, nonzero means failure, just like the exit status of an external utility. Your EC variable trick works but such indirectness isn't necessary.

Code:
g1 () {
        if [ something ]
        then
                echo "success"
                return 0
        else
                echo "failure"
                return 1
        fi
}

This User Gave Thanks to Corona688 For This Post:
# 5  
Old 03-16-2013
Thank you Corona688
I follow yours instructions.

I put an error in the first line (13 for the month)
Code:
cat inputfile
2013-13-31 12 05
2012-12-01 05 24
2011-02-21 09 15

When i launch the script, there are malfunctions.
1) Each line with right or wrong paramaters are printed twice.
I would like the line that has an error is not edited.
It should only return the error code.
And others to be edited once.


Can you correct this script ?
Thank you in advance.

Code:
./my_script inputfile
Fatal, $1 = '2013-13-31', Date not conform OR absent
Errors found in date/time - exiting now
2013-13-31 12 05 line 1
2012-12-01 05 24 line 2
2011-02-21 09 15 line 3
2013-13-31 12 05 line 1
2012-12-01 05 24 line 2
2011-02-21 09 15 line 3

Code:
#!/bin/sh
#########################################################################
g1() {
case "$1" in
([1-9][0-9][0-9][0-9]-0[1-9]-0[1-9] | [1-9][0-9][0-9][0-9]-0[1-9]-1[0-9]  | [1-9][0-9][0-9][0-9]-0[1-9]-2[0-9] |  [1-9][0-9][0-9][0-9]-0[1-9]-3[0-1] | [1-9][0-9][0-9][0-9]-1[0-2]-0[1-9] |  [1-9][0-9][0-9][0-9]-1[0-2]-1[0-9] | [1-9][0-9][0-9][0-9]-1[0-2]-2[0-9]  | [1-9][0-9][0-9][0-9]-1[0-2]-3[0-1])
# RAS, OK !
return 0;
  ;;
(*)
  echo 'Fatal, $1 = '"'$1'"', Date not conform OR absent' >&2
;;
esac
return 1

case "$2" in
([01][0-9] | 2[0-3])
  # nothing, OK !
return 0;
  ;;
(*)
  echo 'Fatal, $2 = '"'$2'"', Hour 2 digits between 00 and 23' >&2
  ;;
esac
return 1

case "$3" in
([01][0-9] | [2-5][0-9])
  # nothing, OK !
return 0;
  ;;
(*)
  echo 'Fatal, $3 = '"'$3'"', Minute in two digits between 00 and 59' >&2
esac
return 1
}

f1() {
echo $1 $2 $3 "line" $4
#[ $1 = $1 ]
}
case $# in
        0)      echo -e "# comment\n# commentaire2" > list_file
                read -p "Please fill in this list_file: "

                echo $REPLY
                ;;
        1)     if [ ! -f "$1" ]
               then  > $1 && echo -e "# comment\n# comment" > $1
                        read -p "Please fill in "$1": "
                        echo $REPLY
               else
                        if [ -f "$1" -a $(grep -v '^#' "$1" | wc -l ) -ne 0 ]
                        then
                                grep -v '^#' "$1" |
                                while read arg1 arg2 arg3
                                do
                                if ! g1 $arg1 $arg2 $arg3
                                 then
                                        echo "Errors found in date/time - exiting now" >&2
                                        #exit 1
                                else

                                        grep -v '^#' "$1" |
                                                while read arg1 arg2 arg3
                                                do f1 $arg1 $arg2 $arg3 $((++line))
                                                done
                                 fi
                                done
                        else
                                read -p "Please fill in "$1": "
                                echo $REPLY
                        fi
                fi
               ;;
  *)      echo "error msg"; exit
esac

# 6  
Old 03-17-2013
Do not PM people to bring them back faster. PMing people for technical support is against the rules.

That program is so big and messy I can't tell what you're trying to do, let alone what's wrong with it. Suspect there's a far simpler way to do what you want, whatever it is. Please explain its purpose.
# 7  
Old 03-18-2013
Code:
f1() {
echo $1 $2 $3 "line" $4

Here f1 is a simple function to test the function g1.
g1 is a function which tests the parameters format of an input file.
Theses parameters are YEAR BEGIN_hour END_hour.
Month must be between 1 and 12
Day must be between 1 and 31
Hour must be between 00 and 23 (2 digits)
Minutes must be between 00 and 59 (2 digits)

case 0)
If the script is launched without argument, an inputfile named list_file will be created with comments.
The main engine ie case 1)
If the inputfile exists, the script tests if there are parameters.
Then it parses each parameters to check the validity of the format

When i launch the script, there are malfunctions.
1) Each line with right or wrong parameters are printed twice.
I would like the line that has an error is not printed. It should only return the error code.
And others to be edited once.

I hope to be clearer.

Have a nice day.

Code:
case $# in
        0)      echo -e "# comment1\n# comment2" > list_file
                read -p "Please fill in this list_file: "

                echo $REPLY
                ;;
        1)     if [ ! -f "$1" ]
               then  > $1 && echo -e "# comment1\n# comment1" > $1
                        read -p "Please fill in "$1": "

                        echo $REPLY
               else
                        if [ -f "$1" -a $(grep -v '^#' "$1" | wc -l ) -ne 0 | $(g1 $arg1 $arg2 $arg3) -ne 0 ] # line 58
                        then
                                grep -v '^#' "$1" |
                                                while read arg1 arg2 arg3
                                                do f1 $arg1 $arg2 $arg3
                                                done
                         else
                                        echo "Errors found in date/time - exiting now" >&2
                                        exit 1
                          fi
                                read -p "Please fill in "$1": "
                                echo $REPLY
                fi
               ;;

        3)      echo -e "# Fill in the 3 variables below\n# DATE HOUR MN" > $1
                echo $2 $3 $4 >> "$1"                  # concatenation of variables in $ 1
                                grep -v '^#' "$1" | # Omits the comments
                                while read arg1 arg2 arg3 # Parse the parameters
                                do f1 $arg1 $arg2 $arg3 # Processing parameters for the function f1
                                done
                ;;
 *)      echo "error msg"; exit
esac

Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Function - Make your function return an exit status

Hi All, Good Day, seeking for your assistance on how to not perform my 2nd, 3rd,4th etc.. function if my 1st function is in else condition. #Body function1() { if then echo "exist" else echo "not exist" } #if not exist in function1 my all other function will not proceed.... (4 Replies)
Discussion started by: meister29
4 Replies

2. Shell Programming and Scripting

Will files, creaetd in one function of the same script will be recognized in another function?

Dear All. I have a script, which process files one by one. In the script I have two functions. one sftp files to different server the other from existing file create file with different name. My question is: Will sftp function recognize files names , which are created in another... (1 Reply)
Discussion started by: digioleg54
1 Replies

3. Shell Programming and Scripting

Help to Modify File Name in each function before calling another function.

I have a script which does gunzip, zip and untar. Input to the script is file name and file directory (where file is located) I am reading the input parameters as follows: FILENAME=$1 FILEDIR=$2 I have created 3 functions that are as follows: 1) gunzip file 2) unzip file... (2 Replies)
Discussion started by: pinnacle
2 Replies

4. Shell Programming and Scripting

If condition return 0 even when it fails to satisfy te condition

HI My doubt may be basic one but I need to get it clarified.. When i use "if" condition that checks for many AND, OR logical conditions like if ]; then return 0 fi Even the if condition fails it returns as zero.. Any clue.. But if i add else condition like if ]; ... (2 Replies)
Discussion started by: Priya Amaresh
2 Replies

5. Shell Programming and Scripting

redirect stdout echo command in condition A run in condition B

hi, I have some problems in my simple script about the redirect echo stdout command inside a condition. Why is the echo command inside the elif still execute in the else command Here are my simple script After check on the two diff output the echo stdout redirect is present in two diff... (3 Replies)
Discussion started by: jao_madn
3 Replies

6. HP-UX

Difference between [condition] and [[condition]] and ((condition)) when used with if condition

Executed the following if conditions .. and got different results . only (( )) gave correct o/p with all scenarios . Can anybody please let me know what is the difference between and ] and ((condition)) when used with if condition. And why each condition gave different result. 1.... (2 Replies)
Discussion started by: soumyabubun
2 Replies

7. Programming

performance issues of calling a function in if condition

Hi, I have written a program in C and have to test the return value of the functions. So the normal way of doin this wud b int rc rc=myfunction(input); if(rc=TRUE){ } else{ } But instead of doing this I have called the function in the if() condition. Does this have any... (2 Replies)
Discussion started by: sidmania
2 Replies

8. Shell Programming and Scripting

race condition with wait() function

Hi, I'm currently writing a bash script, that starts multiple threads: ____________________ #!/bin/bash loop=0 while((loop!=10)) do thread & ((loop++)) done #wait for all sub-processes (thread) to finish wait ___________________ Now I want to know, what happens, if a... (2 Replies)
Discussion started by: tho99
2 Replies

9. Shell Programming and Scripting

Passing global variable to a function which is called by another function

Hi , I have three funcions f1, f2 and f3 . f1 calls f2 and f2 calls f3 . I have a global variable "period" which i want to pass to f3 . Can i pass the variable directly in the definition of f3 ? Pls help . sars (4 Replies)
Discussion started by: sars
4 Replies

10. Shell Programming and Scripting

problem, with if condition in function

Hi All, I have a function which reads parameter and gets the value from config file. The entry in the file can be either of two Name=value or Name=value so if the variant is not present it should return me the generic value ie Name without variant. I am first searching for variant in... (4 Replies)
Discussion started by: gurukottur
4 Replies
Login or Register to Ask a Question